commit 256c879b9614b9e0c7254e448fda6805da743db8
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Jul 25 15:32:14 2008 +0000

    Update des DHTML-Tab-Scripts auf Version 2.2.

diff --git a/SL/Form.pm b/SL/Form.pm
index a06c363e8..5a2ad9203 100644
--- a/SL/Form.pm
+++ b/SL/Form.pm
@@ -617,15 +617,15 @@ sub header {
 
   <meta name="robots" content="noindex,nofollow" />
   <script type="text/javascript" src="js/highlight_input.js"></script>
-  <link rel="stylesheet" type="text/css" href="css/tabcontent.css" />
 
+  <link rel="stylesheet" type="text/css" href="css/tabcontent.css" />
   <script type="text/javascript" src="js/tabcontent.js">
 
   /***********************************************
-  * Tab Content script- Dynamic Drive DHTML code library (www.dynamicdrive.com)
-  * This notice MUST stay intact for legal use
-  * Visit Dynamic Drive at http://www.dynamicdrive.com/ for full source code
-  ***********************************************/
+   * Tab Content script v2.2- © Dynamic Drive DHTML code library (www.dynamicdrive.com)
+   * This notice MUST stay intact for legal use
+   * Visit Dynamic Drive at http://www.dynamicdrive.com/ for full source code
+   ***********************************************/
 
   </script>
 
diff --git a/css/shade.gif b/css/shade.gif
deleted file mode 100644
index 72b13c587..000000000
Binary files a/css/shade.gif and /dev/null differ
diff --git a/css/shadeactive.gif b/css/shadeactive.gif
deleted file mode 100644
index e5c8097e3..000000000
Binary files a/css/shadeactive.gif and /dev/null differ
diff --git a/css/tabcontent.css b/css/tabcontent.css
index 25226e284..5b614167b 100644
--- a/css/tabcontent.css
+++ b/css/tabcontent.css
@@ -1,63 +1,176 @@
-.shadetabs{
-padding: 3px 0;
-margin-left: 0;
-margin-top: 1px;
-margin-bottom: 0;
-font: bold 12px Verdana;
-list-style-type: none;
-text-align: left; /*set to left, center, or right to align the menu as desired*/
-}
-
-.shadetabs li{
-display: inline;
-margin: 0;
-}
-
-.shadetabs li a{
-text-decoration: none;
-padding: 3px 7px;
-margin-right: 3px;
-border: 1px solid #778;
-color: #2d2b2b;
-background: white url(shade.gif) top left repeat-x;
-}
-
-.shadetabs li a:visited{
-color: #2d2b2b;
-}
-
-.shadetabs li a:hover{
-text-decoration: underline;
-color: #2d2b2b;
-}
-
-.shadetabs li.selected{
-position: relative;
-top: 1px;
-}
-
-.shadetabs li.selected a{ /*selected main tab style */
-background-image: url(shadeactive.gif);
-border-bottom-color: white;
-}
-
-.shadetabs li.selected a:hover{ /*selected main tab style */
-text-decoration: none;
-}
-
-.tabcontentstyle{ /*style of tab content oontainer*/
-border: 1px solid gray;
-width: 90%;
-margin-bottom: 1em;
-padding: 10px;
-}
-
-.tabcontent{
-display:none;
-}
-
-@media print {
-.tabcontent {
-display:block!important;
-}
+/* ######### CSS for Shade Tabs. Remove if not using ######### */
+
+.shadetabs{
+padding: 3px 0;
+margin-left: 0;
+margin-top: 1px;
+margin-bottom: 0;
+font: bold 12px Verdana;
+list-style-type: none;
+text-align: left; /*set to left, center, or right to align the menu as desired*/
+}
+
+.shadetabs li{
+display: inline;
+margin: 0;
+}
+
+.shadetabs li a{
+text-decoration: none;
+position: relative;
+z-index: 1;
+padding: 3px 7px;
+margin-right: 3px;
+border: 1px solid #778;
+color: #2d2b2b;
+background: white url(../image/shade.gif) top left repeat-x;
+}
+
+.shadetabs li a:visited{
+color: #2d2b2b;
+}
+
+.shadetabs li a:hover{
+text-decoration: underline;
+color: #2d2b2b;
+}
+
+.shadetabs li a.selected{ /*selected main tab style */
+position: relative;
+top: 1px;
+}
+
+.shadetabs li a.selected{ /*selected main tab style */
+background-image: url(../image/shadeactive.gif);
+border-bottom-color: white;
+}
+
+.shadetabs li a.selected:hover{ /*selected main tab style */
+text-decoration: none;
+}
+
+.tabcontent{
+display:none;
+}
+
+@media print {
+.tabcontent {
+display:block !important;
+}
+}
+
+/* ######### CSS for Inverted Modern Bricks II Tabs. Remove if not using ######### */
+
+.modernbricksmenu2{
+padding: 0;
+width: 362px;
+border-top: 5px solid #D25A0B; /*Brown color theme*/ 
+background: transparent;
+voice-family: "\"}\"";
+voice-family: inherit;
+}
+
+.modernbricksmenu2 ul{
+margin:0;
+margin-left: 10px; /*margin between first menu item and left browser edge*/
+padding: 0;
+list-style: none;
+}
+
+.modernbricksmenu2 li{
+display: inline;
+margin: 0 2px 0 0;
+padding: 0;
+text-transform:uppercase;
+}
+
+.modernbricksmenu2 a{
+float: left;
+display: block;
+font: bold 11px Arial;
+color: white;
+text-decoration: none;
+margin: 0 1px 0 0; /*Margin between each menu item*/
+padding: 5px 10px;
+background-color: black; /*Brown color theme*/ 
+border-top: 1px solid white;
+}
+
+.modernbricksmenu2 a:hover{
+background-color: #D25A0B; /*Brown color theme*/ 
+color: white;
+}
+
+.modernbricksmenu2 a.selected{ /*currently selected tab*/
+background-color: #D25A0B; /*Brown color theme*/ 
+color: white;
+border-color: #D25A0B; /*Brown color theme*/ 
+}
+
+.tabcontent{
+display:none;
+}
+
+@media print {
+.tabcontent {
+display:block !important;
+}
+}
+
+/* ######### CSS for Indented CSS Tabs. Remove if not using ######### */
+
+
+.indentmenu{
+font: bold 13px Arial;
+width: 100%; /*leave this value as is in most cases*/
+}
+
+.indentmenu ul{
+margin: 0;
+padding: 0;
+float: left;
+/* width: 80%; width of menu*/
+border-top: 1px solid navy; /*navy border*/
+background: black url(../image/indentbg.gif) center center repeat-x;
+}
+
+.indentmenu ul li{
+display: inline;
+}
+
+.indentmenu ul li a{
+float: left;
+color: white; /*text color*/
+padding: 5px 11px;
+text-decoration: none;
+border-right: 1px solid navy; /*navy divider between menu items*/
+}
+
+.indentmenu ul li a:visited{
+color: white;
+}
+
+.indentmenu ul li a.selected{
+color: white !important;
+padding-top: 6px; /*shift text down 1px*/
+padding-bottom: 4px;
+background: black url(../image/indentbg2.gif) center center repeat-x;
+}
+
+
+.tabcontentstyle{ /*style of tab content oontainer*/
+border: 1px solid gray;
+width: 95%;
+margin-bottom: 1em;
+padding: 10px;
+}
+
+.tabcontent{
+display:none;
+}
+
+@media print {
+.tabcontent {
+display:block !important;
+}
 }
\ No newline at end of file
diff --git a/image/indentbg.gif b/image/indentbg.gif
new file mode 100644
index 000000000..d78ffd583
Binary files /dev/null and b/image/indentbg.gif differ
diff --git a/image/indentbg2.gif b/image/indentbg2.gif
new file mode 100644
index 000000000..5c81d8420
Binary files /dev/null and b/image/indentbg2.gif differ
diff --git a/image/shade.gif b/image/shade.gif
new file mode 100644
index 000000000..72b13c587
Binary files /dev/null and b/image/shade.gif differ
diff --git a/image/shadeactive.gif b/image/shadeactive.gif
new file mode 100644
index 000000000..e5c8097e3
Binary files /dev/null and b/image/shadeactive.gif differ
diff --git a/js/tabcontent.js b/js/tabcontent.js
index 243be264b..62f842d07 100644
--- a/js/tabcontent.js
+++ b/js/tabcontent.js
@@ -1,82 +1,159 @@
-//** Tab Content script- © Dynamic Drive DHTML code library (http://www.dynamicdrive.com)
-//** Last updated: June 29th, 06
-
-var enabletabpersistence=1 //enable tab persistence via session only cookies, so selected tab is remembered?
+//** Tab Content script v2.0- © Dynamic Drive DHTML code library (http://www.dynamicdrive.com)
+//** Updated Oct 7th, 07 to version 2.0. Contains numerous improvements:
+//   -Added Auto Mode: Script auto rotates the tabs based on an interval, until a tab is explicitly selected
+//   -Ability to expand/contract arbitrary DIVs on the page as the tabbed content is expanded/ contracted
+//   -Ability to dynamically select a tab either based on its position within its peers, or its ID attribute (give the target tab one 1st)
+//   -Ability to set where the CSS classname "selected" get assigned- either to the target tab's link ("A"), or its parent container
+//** Updated Feb 18th, 08 to version 2.1: Adds a "tabinstance.cycleit(dir)" method to cycle forward or backward between tabs dynamically
+//** Updated April 8th, 08 to version 2.2: Adds support for expanding a tab using a URL parameter (ie: http://mysite.com/tabcontent.htm?tabinterfaceid=0) 
 
 ////NO NEED TO EDIT BELOW////////////////////////
-var tabcontentIDs=new Object()
-
-function expandcontent(linkobj){
-var ulid=linkobj.parentNode.parentNode.id //id of UL element
-var ullist=document.getElementById(ulid).getElementsByTagName("li") //get list of LIs corresponding to the tab contents
-for (var i=0; i<ullist.length; i++){
-ullist[i].className=""  //deselect all tabs
-if (typeof tabcontentIDs[ulid][i]!="undefined") //if tab content within this array index exists (exception: More tabs than there are tab contents)
-document.getElementById(tabcontentIDs[ulid][i]).style.display="none" //hide all tab contents
-}
-linkobj.parentNode.className="selected"  //highlight currently clicked on tab
-document.getElementById(linkobj.getAttribute("rel")).style.display="block" //expand corresponding tab content
-saveselectedtabcontentid(ulid, linkobj.getAttribute("rel"))
-}
 
-function savetabcontentids(ulid, relattribute){// save ids of tab content divs
-if (typeof tabcontentIDs[ulid]=="undefined") //if this array doesn't exist yet
-tabcontentIDs[ulid]=new Array()
-tabcontentIDs[ulid][tabcontentIDs[ulid].length]=relattribute
+function ddtabcontent(tabinterfaceid){
+	this.tabinterfaceid=tabinterfaceid //ID of Tab Menu main container
+	this.tabs=document.getElementById(tabinterfaceid).getElementsByTagName("a") //Get all tab links within container
+	this.enabletabpersistence=true
+	this.hottabspositions=[] //Array to store position of tabs that have a "rel" attr defined, relative to all tab links, within container
+	this.currentTabIndex=0 //Index of currently selected hot tab (tab with sub content) within hottabspositions[] array
+	this.subcontentids=[] //Array to store ids of the sub contents ("rel" attr values)
+	this.revcontentids=[] //Array to store ids of arbitrary contents to expand/contact as well ("rev" attr values)
+	this.selectedClassTarget="link" //keyword to indicate which target element to assign "selected" CSS class ("linkparent" or "link")
 }
 
-function saveselectedtabcontentid(ulid, selectedtabid){ //set id of clicked on tab as selected tab id & enter into cookie
-if (enabletabpersistence==1) //if persistence feature turned on
-setCookie(ulid, selectedtabid)
+ddtabcontent.getCookie=function(Name){ 
+	var re=new RegExp(Name+"=[^;]+", "i"); //construct RE to search for target name/value pair
+	if (document.cookie.match(re)) //if cookie found
+		return document.cookie.match(re)[0].split("=")[1] //return its value
+	return ""
 }
 
-function getullistlinkbyId(ulid, tabcontentid){ //returns a tab link based on the ID of the associated tab content
-var ullist=document.getElementById(ulid).getElementsByTagName("li")
-for (var i=0; i<ullist.length; i++){
-if (ullist[i].getElementsByTagName("a")[0].getAttribute("rel")==tabcontentid){
-return ullist[i].getElementsByTagName("a")[0]
-break
-}
-}
+ddtabcontent.setCookie=function(name, value){
+	document.cookie = name+"="+value+";path=/" //cookie value is domain wide (path=/)
 }
 
-function initializetabcontent(){
-for (var i=0; i<arguments.length; i++){ //loop through passed UL ids
-if (enabletabpersistence==0 && getCookie(arguments[i])!="") //clean up cookie if persist=off
-setCookie(arguments[i], "")
-var clickedontab=getCookie(arguments[i]) //retrieve ID of last clicked on tab from cookie, if any
-var ulobj=document.getElementById(arguments[i])
-var ulist=ulobj.getElementsByTagName("li") //array containing the LI elements within UL
-for (var x=0; x<ulist.length; x++){ //loop through each LI element
-var ulistlink=ulist[x].getElementsByTagName("a")[0]
-if (ulistlink.getAttribute("rel")){
-savetabcontentids(arguments[i], ulistlink.getAttribute("rel")) //save id of each tab content as loop runs
-ulistlink.onclick=function(){
-expandcontent(this)
-return false
-}
-if (ulist[x].className=="selected" && clickedontab=="") //if a tab is set to be selected by default
-expandcontent(ulistlink) //auto load currenly selected tab content
-}
-} //end inner for loop
-if (clickedontab!=""){ //if a tab has been previously clicked on per the cookie value
-var culistlink=getullistlinkbyId(arguments[i], clickedontab)
-if (typeof culistlink!="undefined") //if match found between tabcontent id and rel attribute value
-expandcontent(culistlink) //auto load currenly selected tab content
-else //else if no match found between tabcontent id and rel attribute value (cookie mis-association)
-expandcontent(ulist[0].getElementsByTagName("a")[0]) //just auto load first tab instead
-}
-} //end outer for loop
-}
+ddtabcontent.prototype={
 
+	expandit:function(tabid_or_position){ //PUBLIC function to select a tab either by its ID or position(int) within its peers
+		this.cancelautorun() //stop auto cycling of tabs (if running)
+		var tabref=""
+		try{
+			if (typeof tabid_or_position=="string" && document.getElementById(tabid_or_position).getAttribute("rel")) //if specified tab contains "rel" attr
+				tabref=document.getElementById(tabid_or_position)
+			else if (parseInt(tabid_or_position)!=NaN && this.tabs[tabid_or_position].getAttribute("rel")) //if specified tab contains "rel" attr
+				tabref=this.tabs[tabid_or_position]
+		}
+		catch(err){alert("Invalid Tab ID or position entered!")}
+		if (tabref!="") //if a valid tab is found based on function parameter
+			this.expandtab(tabref) //expand this tab
+	},
 
-function getCookie(Name){ 
-var re=new RegExp(Name+"=[^;]+", "i"); //construct RE to search for target name/value pair
-if (document.cookie.match(re)) //if cookie found
-return document.cookie.match(re)[0].split("=")[1] //return its value
-return ""
-}
+	cycleit:function(dir, autorun){ //PUBLIC function to move foward or backwards through each hot tab (tabinstance.cycleit('foward/back') )
+		if (dir=="next"){
+			var currentTabIndex=(this.currentTabIndex<this.hottabspositions.length-1)? this.currentTabIndex+1 : 0
+		}
+		else if (dir=="prev"){
+			var currentTabIndex=(this.currentTabIndex>0)? this.currentTabIndex-1 : this.hottabspositions.length-1
+		}
+		if (typeof autorun=="undefined") //if cycleit() is being called by user, versus autorun() function
+			this.cancelautorun() //stop auto cycling of tabs (if running)
+		this.expandtab(this.tabs[this.hottabspositions[currentTabIndex]])
+	},
+
+	setpersist:function(bool){ //PUBLIC function to toggle persistence feature
+			this.enabletabpersistence=bool
+	},
+
+	setselectedClassTarget:function(objstr){ //PUBLIC function to set which target element to assign "selected" CSS class ("linkparent" or "link")
+		this.selectedClassTarget=objstr || "link"
+	},
+
+	getselectedClassTarget:function(tabref){ //Returns target element to assign "selected" CSS class to
+		return (this.selectedClassTarget==("linkparent".toLowerCase()))? tabref.parentNode : tabref
+	},
+
+	urlparamselect:function(tabinterfaceid){
+		var result=window.location.search.match(new RegExp(tabinterfaceid+"=(\\d+)", "i")) //check for "?tabinterfaceid=2" in URL
+		return (result==null)? null : parseInt(RegExp.$1) //returns null or index, where index (int) is the selected tab's index
+	},
+
+	expandtab:function(tabref){
+		var subcontentid=tabref.getAttribute("rel") //Get id of subcontent to expand
+		//Get "rev" attr as a string of IDs in the format ",john,george,trey,etc," to easily search through
+		var associatedrevids=(tabref.getAttribute("rev"))? ","+tabref.getAttribute("rev").replace(/\s+/, "")+"," : ""
+		this.expandsubcontent(subcontentid)
+		this.expandrevcontent(associatedrevids)
+		for (var i=0; i<this.tabs.length; i++){ //Loop through all tabs, and assign only the selected tab the CSS class "selected"
+			this.getselectedClassTarget(this.tabs[i]).className=(this.tabs[i].getAttribute("rel")==subcontentid)? "selected" : ""
+		}
+		if (this.enabletabpersistence) //if persistence enabled, save selected tab position(int) relative to its peers
+			ddtabcontent.setCookie(this.tabinterfaceid, tabref.tabposition)
+		this.setcurrenttabindex(tabref.tabposition) //remember position of selected tab within hottabspositions[] array
+	},
+
+	expandsubcontent:function(subcontentid){
+		for (var i=0; i<this.subcontentids.length; i++){
+			var subcontent=document.getElementById(this.subcontentids[i]) //cache current subcontent obj (in for loop)
+			subcontent.style.display=(subcontent.id==subcontentid)? "block" : "none" //"show" or hide sub content based on matching id attr value
+		}
+	},
+
+	expandrevcontent:function(associatedrevids){
+		var allrevids=this.revcontentids
+		for (var i=0; i<allrevids.length; i++){ //Loop through rev attributes for all tabs in this tab interface
+			//if any values stored within associatedrevids matches one within allrevids, expand that DIV, otherwise, contract it
+			document.getElementById(allrevids[i]).style.display=(associatedrevids.indexOf(","+allrevids[i]+",")!=-1)? "block" : "none"
+		}
+	},
+
+	setcurrenttabindex:function(tabposition){ //store current position of tab (within hottabspositions[] array)
+		for (var i=0; i<this.hottabspositions.length; i++){
+			if (tabposition==this.hottabspositions[i]){
+				this.currentTabIndex=i
+				break
+			}
+		}
+	},
+
+	autorun:function(){ //function to auto cycle through and select tabs based on a set interval
+		this.cycleit('next', true)
+	},
+
+	cancelautorun:function(){
+		if (typeof this.autoruntimer!="undefined")
+			clearInterval(this.autoruntimer)
+	},
+
+	init:function(automodeperiod){
+		var persistedtab=ddtabcontent.getCookie(this.tabinterfaceid) //get position of persisted tab (applicable if persistence is enabled)
+		var selectedtab=-1 //Currently selected tab index (-1 meaning none)
+		var selectedtabfromurl=this.urlparamselect(this.tabinterfaceid) //returns null or index from: tabcontent.htm?tabinterfaceid=index
+		this.automodeperiod=automodeperiod || 0
+		for (var i=0; i<this.tabs.length; i++){
+			this.tabs[i].tabposition=i //remember position of tab relative to its peers
+			if (this.tabs[i].getAttribute("rel")){
+				var tabinstance=this
+				this.hottabspositions[this.hottabspositions.length]=i //store position of "hot" tab ("rel" attr defined) relative to its peers
+				this.subcontentids[this.subcontentids.length]=this.tabs[i].getAttribute("rel") //store id of sub content ("rel" attr value)
+				this.tabs[i].onclick=function(){
+					tabinstance.expandtab(this)
+					tabinstance.cancelautorun() //stop auto cycling of tabs (if running)
+					return false
+				}
+				if (this.tabs[i].getAttribute("rev")){ //if "rev" attr defined, store each value within "rev" as an array element
+					this.revcontentids=this.revcontentids.concat(this.tabs[i].getAttribute("rev").split(/\s*,\s*/))
+				}
+				if (selectedtabfromurl==i || this.enabletabpersistence && selectedtab==-1 && parseInt(persistedtab)==i || !this.enabletabpersistence && selectedtab==-1 && this.getselectedClassTarget(this.tabs[i]).className=="selected"){
+					selectedtab=i //Selected tab index, if found
+				}
+			}
+		} //END for loop
+		if (selectedtab!=-1) //if a valid default selected tab index is found
+			this.expandtab(this.tabs[selectedtab]) //expand selected tab (either from URL parameter, persistent feature, or class="selected" class)
+		else //if no valid default selected index found
+			this.expandtab(this.tabs[this.hottabspositions[0]]) //Just select first tab that contains a "rel" attr
+		if (parseInt(this.automodeperiod)>500 && this.hottabspositions.length>1){
+			this.autoruntimer=setInterval(function(){tabinstance.autorun()}, this.automodeperiod)
+		}
+	} //END int() function
 
-function setCookie(name, value){
-document.cookie = name+"="+value //cookie value is domain wide (path=/)
-}
\ No newline at end of file
+} //END Prototype assignment
\ No newline at end of file
diff --git a/templates/webpages/ct/form_footer_de.html b/templates/webpages/ct/form_footer_de.html
index b8b9aaeaf..12c08e8b7 100644
--- a/templates/webpages/ct/form_footer_de.html
+++ b/templates/webpages/ct/form_footer_de.html
@@ -33,8 +33,18 @@
 
  <script type="text/javascript">
   <!--
-      //Start Tab Content script for UL with id="maintab".
-      initializetabcontent("maintab");
+      Calendar.setup({ inputField : "fromB",   ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_from" });
+      Calendar.setup({ inputField : "toB",     ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_to" });
+      Calendar.setup({ inputField : "FU_date", ifFormat :"[% myconfig_jsc_dateformat %]", align : "BR", button : "FU_date_trigger" });
+
+      function enable_delete_shipto(used) { var s=document.getElementById('delete_shipto');  if (s) s.disabled = (used > 0 ? true : false); }
+      function enable_delete_contact(used){ var s=document.getElementById('delete_contact'); if (s) s.disabled = (used > 0 ? true : false); }
+
+      var maintab = new ddtabcontent("maintab");
+      maintab.setpersist(true);
+      maintab.setselectedClassTarget("link"); //"link" or "linkparent"
+      maintab.init();
+
     -->
  </script>
 </body>
diff --git a/templates/webpages/ct/form_footer_master.html b/templates/webpages/ct/form_footer_master.html
index e39e4faee..7758a120d 100644
--- a/templates/webpages/ct/form_footer_master.html
+++ b/templates/webpages/ct/form_footer_master.html
@@ -33,8 +33,18 @@
 
  <script type="text/javascript">
   <!--
-      //Start Tab Content script for UL with id="maintab".
-      initializetabcontent("maintab");
+      Calendar.setup({ inputField : "fromB",   ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_from" });
+      Calendar.setup({ inputField : "toB",     ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_to" });
+      Calendar.setup({ inputField : "FU_date", ifFormat :"[% myconfig_jsc_dateformat %]", align : "BR", button : "FU_date_trigger" });
+
+      function enable_delete_shipto(used) { var s=document.getElementById('delete_shipto');  if (s) s.disabled = (used > 0 ? true : false); }
+      function enable_delete_contact(used){ var s=document.getElementById('delete_contact'); if (s) s.disabled = (used > 0 ? true : false); }
+
+      var maintab = new ddtabcontent("maintab");
+      maintab.setpersist(true);
+      maintab.setselectedClassTarget("link"); //"link" or "linkparent"
+      maintab.init();
+
     -->
  </script>
 </body>
diff --git a/templates/webpages/ct/form_header_de.html b/templates/webpages/ct/form_header_de.html
index 6a3749edc..7cee89487 100644
--- a/templates/webpages/ct/form_header_de.html
+++ b/templates/webpages/ct/form_header_de.html
@@ -588,14 +588,3 @@
    [%- END %]
 
   </div>
-
-  <script type="text/javascript">
-   <!--
-       Calendar.setup({ inputField : "fromB",   ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_from" });
-       Calendar.setup({ inputField : "toB",     ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_to" });
-       Calendar.setup({ inputField : "FU_date", ifFormat :"[% myconfig_jsc_dateformat %]", align : "BR", button : "FU_date_trigger" });
-       //-->
-
-   function enable_delete_shipto(used) { var s=document.getElementById('delete_shipto');  if (s) s.disabled = (used > 0 ? true : false); }
-   function enable_delete_contact(used){ var s=document.getElementById('delete_contact'); if (s) s.disabled = (used > 0 ? true : false); }
-  </script>
diff --git a/templates/webpages/ct/form_header_master.html b/templates/webpages/ct/form_header_master.html
index 0ab1afffd..f5b5551cf 100644
--- a/templates/webpages/ct/form_header_master.html
+++ b/templates/webpages/ct/form_header_master.html
@@ -588,14 +588,3 @@
    [%- END %]
 
   </div>
-
-  <script type="text/javascript">
-   <!--
-       Calendar.setup({ inputField : "fromB",   ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_from" });
-       Calendar.setup({ inputField : "toB",     ifFormat :"[% myconfig_jsc_dateformat %]", align : "BL", button : "trigger_to" });
-       Calendar.setup({ inputField : "FU_date", ifFormat :"[% myconfig_jsc_dateformat %]", align : "BR", button : "FU_date_trigger" });
-       //-->
-
-   function enable_delete_shipto(used) { var s=document.getElementById('delete_shipto');  if (s) s.disabled = (used > 0 ? true : false); }
-   function enable_delete_contact(used){ var s=document.getElementById('delete_contact'); if (s) s.disabled = (used > 0 ? true : false); }
-  </script>